$(document).ready(function() {

	/**************************************************/
	/*     A script globálisan használt változói      */
	/**************************************************/
	
    var zi = 1;				//A mozgásban lévő négyzet mindig legfelül legyen. Minden mozgatásnál növeljük a z-index értékét
 
    var EmptySquare = 16;	//Az üres négyzet indexe, initként a jobb alsó (16.)
	
	var stepCount = 0;		//emberi játékos által tett lépések száma
	
	var prevChoosenSquare = -1;		//Gép keverő algoritmusa által választott legutóbbi elem (initként -1: nincs ilyen)
	
	var movesTaken = 0;				//Gép keverő algoritmusa által tett lépések száma
	
	var goalNumOfMoves = 20;		//Gép keverő algoritmusának célként beállított lépésszám
	
 
 	/**************************************************/
	/*  jquery plugin definiálása 'kepkirako' néven   */
	/**************************************************/
	
    $.fn.extend({ kepkirako:
		
        function(square_size) {

			// Kinyerjük az id-t abból az elemből, amibe a játékot helyezi a plugin felhasználója
			var gameObjectId = $(this).attr('id');
            var gameObjectElement = '#' + gameObjectId;
 
			//a plugin paraméterül kap egy számot, ami a négyzetek mérete pixelben. Ez alapján állapítjuk meg az egész játéktábla méretét
            var boardSize = (square_size * 4) + 'px';
 
            //hozzáfűzzük a játéktáblánkat tároló divet a gameObjectElementhez
            $(gameObjectElement).html('<div id="board"></div>');
 
			//beállítjuk a tábla dinamikus stílusát
            $('#board').css({
				width: boardSize,
				height: boardSize
			});
 
            // a játéktábla divet feltöltjük 15 négyzettel
            for (var i = 0; i < 16; i++) {
                //Minden négyzet ugyanazt a képet használja, csak más x/y offset értékkel
                $('#board').append(
					"<div style='left: " + ((i % 4) * square_size) + "px;" +
					"top: " + Math.floor(i / 4) * square_size + "px;" +
					"width: " + square_size + "px;" +
					"height: " + square_size + "px;" +
					"background-position: " + (-(i % 4) * square_size) + "px " + -Math.floor(i / 4) * square_size + "px '>" +
					"</div>"
				);
            }
 
            //Az üres négyzet inicializálása
            $('#board').children("div:nth-child(" + EmptySquare + ")").css(
				{
					backgroundImage: "",
					background: "#ffffff"
				});
 
            //eseménykezelő hozzáadása a négyzetekre való kattintáshoz
            $('#board').children('div').click(function() {
                Move(this, square_size, 200, false);
            });
			
			//hozzáfűzzük a vezérlőt(HUD) tároló divet gameObjectElementhez
            $(gameObjectElement).append(
				'<div id="hud">' +
				'<span style="margin-left: 5px;">Lépések száma: </span><span id="stepCounter">' + stepCount + '</span>' +
				'<button id="ResetButton" type="button" data-targetid="'+ gameObjectId + '" class="generatedButtonStyleGreen" style="margin-left: 20px; margin-right: 10px;">Alaphelyzet</button>' +
				'<button id="ShuffleButton" type="button" data-targetid="'+ gameObjectId + '" data-movestotake="20" class="generatedButtonStyle" style="margin-left: 5px;">Kever (20)</button>' +
				'<button id="ShuffleButton" type="button" data-targetid="'+ gameObjectId + '" data-movestotake="50" class="generatedButtonStyle" style="margin-left: 5px;">Kever (50)</button>' +
				'<button id="ShuffleButton" type="button" data-targetid="'+ gameObjectId + '" data-movestotake="100" class="generatedButtonStyle" style="margin-left: 5px;">Kever (100)</button>' +
				'</div>');
			
			//beállítjuk a HUD dinamikus stílusát
            $('#hud').css({
				width: boardSize
			});

        }
    });
	
	/**************************************************/
	/* Eseménykezelő metódusok kötése az eseményekhez */
	/**************************************************/
	
	//Az alaphelyzet gombra kattintva visszaállítjuk az eredeti paramétereket és játékállapotot
	$(document).on("click","#ResetButton",function(){
	
		var gameObjectElementId = $(this).data('targetid');		//a kattintott gomb hordozza azt az információt, hogy milyen id-val rendelkezik az a DOM elem, amibe a játék plugint töltötték
		var gameObjectElement = '#' + gameObjectElementId;
		Reset(gameObjectElement)
		
	});
	
	//A keverés gombra kattintva a gép adott lépésszámig véletlenszerűen összekeveri a játéktáblát
	$(document).on("click","#ShuffleButton",function(){

		var movesTotake = $(this).data('movestotake');			//a kattintott gomb hordozza azt az információt, hogy hány lépésben kell keverni
		
		//keverő paraméterek alaphelyezetbe állítása a korábbi futás után
		movesTaken = 0;
		prevChoosenSquare = -1;
		
		//a cél keverésszám beállítása és a keverő algoritmus indítása
		goalNumOfMoves = movesTotake;
		Shuffle();
		
	});
 
	//(A négyzetekre való klikkelést a plugin belsejében kötöttük)
	
	
	/**************************************************/
	/*             Eseménykezelő metódusok            */
	/**************************************************/
	
    // Ez az eseménykezelő metódus fut le, amikor egy négyzetre kattint a játékos
    // Paraméterek:
    //     	1. clicked_square: a kattintott négyzet dom objektuma
    //     	2. square_size: a kattintott négyzet mérete
	//		3. animation_speed: animáció gyorsasága milisecben
	//		4. isAIStep: true: AI keverő algoritmus lép, false: emberi játékos lép
    function Move(clicked_square, square_size, animation_speed, isAIStep) {
	
		//mozgatható-e a kattintott négyzet objektum (az üres négyzet 4 szomszédos négyzete mozgatható
        var canMove = false;
 
        //az üres négyzet és a kattintott négyzet x/y párjainak lekérése
        var oldx = $('#board').children("div:nth-child(" + EmptySquare + ")").css('left');
        var oldy = $('#board').children("div:nth-child(" + EmptySquare + ")").css('top');
 
        var newx = $(clicked_square).css('left');
        var newy = $(clicked_square).css('top');
 
		//A kattintott négyzet az üres négyzet...
        //...tetején van
        if (oldx == newx && newy == (parseInt(oldy) - square_size) + 'px')
            canMove = true;
 
        //...alján van
        if (oldx == newx && newy == (parseInt(oldy) + square_size) + 'px')
            canMove = true;
 
        //...bal oldalán van
        if ((parseInt(oldx) - square_size) + 'px' == newx && newy == oldy)
            canMove = true;
 
        //...jobb oldalán van
        if ((parseInt(oldx) + square_size) + 'px' == newx && newy == oldy)
            canMove = true;
 
		//ha a kattintott négyzet mozgatható
        if (canMove) {
		
            //az initben deklarált zi változó növelése, hogy a mozgatott négyzet mindig legfelül legyen
            $(clicked_square).css('z-index', zi++);
 
			//lépésszám növelése akkor, ha emberi játékos lépett
			if(!isAIStep)
			{
				stepCount++;
				$("#stepCounter").html(stepCount);
			}
			
            //Új négyzet mozgatása a régi helyére
            $(clicked_square).animate(
				{left: oldx,
				top: oldy },
				animation_speed,
				function() {
                //régi négyzet mozgatása az új helyére
                $('#board').children("div:nth-child(" + EmptySquare + ")").css('left', newx);
                $('#board').children("div:nth-child(" + EmptySquare + ")").css('top', newy);
            });
        }
		
		//visszatérünk azzal, hogy mozgatható volt-e a kattintott négyzet. Ezt az információt a keverő algoritmus fogja csak használni
		return canMove;
    }

	// Ez az eseménykezelő metódus fut le, amikor keverés gombra kattintunk
	function Shuffle()
	{
		//keverés alatt letiltjuk a felhasználói interakciót
		DisableInteractionWhileShuffle();
		
		//lépünk a keverő algoritmussal egyet
		MoveSquareByAI();

		AnimationsTest(function () {
			//callback metódus, miután minden animáció lefutott
			
			//Rekurzívan újra lépünk, ha még nem értük el a kívánt AI lépésszámot
			if(movesTaken < goalNumOfMoves) 
			{
				movesTaken++;
				Shuffle()
			}
			else
			{
				//Keverés után újra engedélyezzük a felhasználói interakciót
				EnableInteractionAfterShuffle();
			}
		});
	}
	
	// Ez az eseménykezelő metódus fut le, amikor az alaphelyzet gombra kattintunk
	// Paraméter gameObject: a DOM objektum, amibe a kepkirako plugint töltötték
	function Reset(gameObject)
	{
		//globális változók alapértékre állítása
		stepCount = 0;
		zi = 1;
		movesTaken = 0;
		prevChoosenSquare = -1;
		
		$(gameObject).kepkirako(150);
	}
	
	
	/**************************************************/
	/*             Egyéb belső metódusok              */
	/**************************************************/
	
	//AI algoritmus lép egyet a játéktáblán
	function MoveSquareByAI()
	{
		var run = true;	//a run változóban tároljuk, hogy fut az algoritmus
		
		while(run)
		{
			//A 16 négyzet közül random kiválasztunk egyet
			var choosenSquare = Math.floor((Math.random() * 15) + 1);
			
			//Ha a kiválasztott négyzet megegyezik az előző iterációban kiválasztottal, akkor újat választunk (ne legyen csiki-csuki)
			while(choosenSquare == prevChoosenSquare)
			{
				choosenSquare = Math.floor((Math.random() * 15) + 1);
			}

			var squareToMove = $("#board").children("div:nth-child(" + choosenSquare + ")");
			var sizeOfSquareToMove = $($(squareToMove)[0]).css("width");		//$(squareToMove) tömböt ad vissza, ezért kell [0] index-szel hivatkozni
			var squareMoved = Move(squareToMove, parseInt(sizeOfSquareToMove), 50, true);
			
			//ha sikerül lépni (olyat választott a random generátor, ami üres négyzettel szomszédos, akkor vége az algoritmusnak
			if(squareMoved)
			{
				prevChoosenSquare = choosenSquare;
				run = false;
			}
		}
	}
	
	//Annak ellenőrzése, hogy lefutott-e minden animáció
	function AnimationsTest (callback) {
		
		//25 milisecundomonként fut le
		var testAnimationInterval = setInterval(function () {
			// $.timers tömben tárolja a JQuery a futás alatt álló és futásra váró animációkat Ha ez a tömb kiürült, akkor lefuttatjuk a callback
			//függvényt, ami így biztosan akkor fut le, ha már nem fut animáció az oldalon.
			if (! $.timers.length) {
				clearInterval(testAnimationInterval);
				callback();
			}
		}, 25);
	};
	
	//Letiltjuk a felületen található gombokat, ezt stílusokkal is jelezzük, és a kurzort is "stoptáblásra" állítjuk
	function DisableInteractionWhileShuffle(){
		$("button").attr("disabled","disabled");
		$("button").removeClass("generatedButtonStyleGreen");
		$("#ResetButton").removeClass("generatedButtonStyle");
		$("button").addClass("generatedButtonStyleDisabled");
		$("button").css("cursor","not-allowed");
	}
	
	//Engedélyezzük a felületen található gombokat, ezt stílusokkal is jelezzük, és a kurzort is "mutatóujjasra" állítjuk
	function EnableInteractionAfterShuffle()
	{
		$("button").removeAttr("disabled");
		$("button").removeClass("generatedButtonStyleDisabled");
		$("button").addClass("generatedButtonStyle");
		$("#ResetButton").addClass("generatedButtonStyleGreen");
		$("button").css("cursor","pointer");
	}
	
	//kezdőjáték létrehozása
    $('#game_object').kepkirako(150);
});